%
%   >> r1 = RectCol( 5, 10 )
%   >> r1 = r1.move( 2, 1 )
%   >> r1.col = 'r';
%   >> r1.draw
%   >> r1.zoom( 2 );
%
classdef RectCol < ShapeCol
  properties 
    len = 0;
    wid = 0;
  end
    
  methods
    function obj = RectCol(len,wid)
       obj@ShapeCol(0,0); 
       obj.len = len;
       obj.wid = wid;
    end
    
    function draw( obj )
      x1 = obj.x; 
      x2 = obj.x + obj.len; 
      y1 = obj.y; 
      y2 = obj.y + obj.wid;
           
      x = [x1,x2,x2,x1,x1];
      y = [y1,y1,y2,y2,y1];
      linespec = ['-',obj.col];
      plot( x, y, linespec );       
    end
    
    % Ausschnitt zoomen um Faktor val
    function zoom( obj, val )
      % Mittelpunkt 
      midX = obj.x + obj.len/2;
      midY = obj.y + obj.wid/2;
      % Grenzen des Zoombereichs 
      minX = midX - obj.len/2 * val;
      maxX = midX + obj.len/2 * val;
      minY = midY - obj.wid/2 * val;
      maxY = midY + obj.wid/2 * val;
      % Ausschnitt whlen 
      axis( [minX, maxX, minY, maxY ] )
    end
  end
end