function AmplResFnc( f0, delta, datei )

   F0 = 1;    % N 
   m  = 0.1;  % kg 
   w0 = 2*pi*f0; 
   
   we = w0/10 : w0/10 : 3*w0; 
   fe = we / (2*pi);
   
   A  = F0 ./ ( m*sqrt( (w0^2 - we.^2).^2 + (2*delta*we).^2 ) );

   xlswrite( datei, [fe',A'] );
   
   maxA = max( A ); 
   plot( fe, A, 'b-', [f0,f0], [0,maxA], 'r:' )
   xlabel( 'f / Hz' )
   ylabel( 'A / m' )
   txt = sprintf( 'f0 = %g Hz, d = %g Hz', f0, delta ); 
   title( txt )
   %title( 'Amplituden-Resonanz-Funktion' )
   