%
%  calcArea berechnet die relative Flche eines Bild-Objekts, 
%    also die Anzahl der Pixel des dunklen Objekts in der Flche 
%    dividiert durch die Gesamtzahl der Pixel des Bildes. 
% 
function p = calcArea()

   % Bild-Datei auwhlen 
   [f,p] = uigetfile( '*.bmp', 'Bild whlen' );
   if( f == 0 )
     return; 
   end
   % absoluten Pfad zusammenbauen
   file_name = [p,f];
   
   % Datei laden 
   A = imread( file_name );
   
   % Gre bestimmen 
   sz = size( A );
   nZ = sz(1);  
   nS = sz(2);

   nBody = 0;    % Zahl der Punkte im Krper zu Beginn auf 0 

   % alle Pixel untersuchen 
   for( z = 1:nZ )
     for( s = 1:nS)
	    % Check ob Farbe nahezu schwarz
        col = sum( int32( A( z, s, : ) ) );
        if( col < 100 )            % 100 ist schon recht dunkel
            nBody = nBody + 1;     % weiteres dunkles Pixel gefunden      
        end
	 end
   end	 

   % prozentuale Flche berechnen 
   f_bild = nZ*nS;
   p = nBody / f_bild * 100;
   
   % Bild zeichnen 
   image( A )
   axis image
   txt = sprintf('Flche = %.1f%% ', p );
   title( txt )
   
end
