%
%  Erstellen Sie die Funktion trapezRegel, die hnlich arbeitet wie die 
%    in der Vorlesung besprochene Funktion rechteckRegel, 
%    nur dass beim Integral ber die Funktion fun zur Flchenberechnung 
%    nicht die Rechteckregel, sondern die Trapezregel verwendet wird. 
%
%    Das Trapez ber einem Intervall ist definiert durch die Werte der 
%    Funktion fun an den jeweils beiden Endpunkten der Teil-Intervalle, 
%    also Trapezflche = ( fun(xn) + fun(xn+1) ) * d / 2. 
%    Zur Zerlegung des Intervalls [a,b] knnen Sie beispielsweise 
%    1000 Teil-Intervalle verwenden.
%
%    Testen Sie die Integration mittels trapezRegel an mehreren, 
%    unterschiedlichen Funktionen.
%
%    >> f = trapezRegel( @f1,  0, 1 )
%    >> f = trapezRegel( @sin, 0, pi/2 )
%
function f = trapezRegel( fun, a, b )
    f = 0;
    N = 1000;
    d = (b-a)/N;
    x = a:d:b;  % x-Intervall erzeugen 
    % alle Teilflchen aufsummieren
    for( n=1:N )
       f = f + ( fun(x(n)) + fun(x(n+1)) ) * d / 2;
    end
